#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

#define NMAX 1000010
#define INF (1 << 30)

struct TrieNode {

	TrieNode *children[3];
	int sum;
	int best;
	int best_option;
    
	TrieNode() {
		this->sum = 0;
		this->best = -INF;
		this->best_option = 0;
		memset(this->children, 0, sizeof(this->children));
	}
};
                           
int N, K;
int W, D;
TrieNode *root;

int next[3] = {1, 2, 0};

void add_list(TrieNode *node, int *list, int position) {
	
	node->sum++;
	if (position == K) {   
		node->best = D * node->sum;
		return ;
	}

	if (node->children[list[position]] == NULL)
		node->children[list[position]] = new TrieNode();
	
	add_list(node->children[list[position]], list, position + 1);

	node->best = -INF;
	for(int i = 0; i < 3; i++) {
		int current_best = 0;
		if (node->children[i])
			current_best = node->children[i]->best;
		if (node->children[next[i]])
			current_best+= W * node->children[next[i]]->sum;
		
		if (node->best < current_best) {
			node->best = current_best;
			node->best_option = i;
		}
	}
}

char type[3] = {'P', 'R', 'S'};

void query(TrieNode *node, int position) {

	if (position == K) {
		printf("\n");
		return ;
	}

	int next_pos = node->best_option;
	if(node->children[next_pos]) {
		printf("%c", type[next_pos]);
		query(node->children[next_pos], position + 1);
	}
	else {
		printf("%c", type[next_pos]);
        for(position = position + 1; position < K; position++)
			printf("%c", type[0]);
		printf("\n");
	}
}                   

int main() {

	freopen("rps.in", "r", stdin);
	freopen("rps.out", "w", stdout);

	int list[NMAX];
    char char_list[NMAX];
    
	root = new TrieNode();

	scanf("%d %d %d %d\n", &N, &K, &W, &D);
	for(; N; N--) {
		scanf("%s", char_list);
		for(int i = 0; i < K; i++) {
			if(char_list[i] == 'P') list[i] = 0;
			if(char_list[i] == 'R') list[i] = 1;
			if(char_list[i] == 'S') list[i] = 2;
		}
		 
		add_list(root, list, 0);
	 	query(root, 0);
	}

	return 0;
}
