// Mugurel Ionut Andreica
// O(N * sizeof(trie)) = approx. O(N^2 * K)

#include <stdio.h>

#define MAX_TRIE_NODES 2111111
#define KMAX 1111111
#define INF 1111111111

char moves[KMAX], answer[KMAX];
int to_number[128];
char to_char[3] = { 'P', 'R', 'S'};
int next[MAX_TRIE_NODES][3], parent[MAX_TRIE_NODES], pnum[MAX_TRIE_NODES], node_level[MAX_TRIE_NODES], cnt[MAX_TRIE_NODES];
int N, K, W, D, root, node, num_nodes, i, j, p, score, best_score, best_node, level;

void FindAnswer(int node) {
	int p;

	//fprintf(stderr, "level=%d node=%d/%d cnt=%d score=%d\n", level, node, num_nodes, cnt[node], score);
	
	if (level == K || cnt[node] == 0) {
		score += D * cnt[node];
		if (score > best_score) {
			best_score = score;
			best_node = node;
		}
		score -= D * cnt[node];
	} else {
		for (p = 0; p < 3; p++) {
			score += W * cnt[next[node][(p + 1) % 3]];
			level++;
			FindAnswer(next[node][p]);
			level--;
			score -= W * cnt[next[node][(p + 1) % 3]];
		}
	}
}

int main() {
	freopen("rps.in", "r", stdin);
	freopen("rps.out", "w", stdout);

	scanf("%d %d %d %d", &N, &K, &W, &D);

	root = num_nodes = 1;
	node_level[root] = 0;
	to_number['P'] = 0;
	to_number['R'] = 1;
	to_number['S'] = 2;
	
	for (i = 1; i <= N; i++) {
		scanf("%s", moves);
		node = root;
		cnt[root]++;
		
		for (j = 0; j < K; j++) {
			for (p = 0; p < 3; p++)
				if (!next[node][p]) {
					num_nodes++;
					next[node][p] = num_nodes;
					parent[num_nodes] = node;
					pnum[num_nodes] = p;
					node_level[num_nodes] = node_level[node] + 1;
				}
			node = next[node][to_number[moves[j]]];
			cnt[node]++;
		}

		best_score = -INF;
		score = level = 0;
		FindAnswer(root);

		answer[K] = 0;
		for (j = K - 1; j >= node_level[best_node]; j--)
			answer[j] = 'P';
		
		for (j = node_level[best_node] - 1, node = best_node; j >= 0; j--) {
			answer[j] = to_char[pnum[node]];
			node = parent[node];
		}
		
		// fprintf(stderr, "best_score=%d best_node=%d best_node_level=%d/%d\n", best_score, best_node, node_level[best_node], K);
		printf("%s\n", answer);
	}
	
	return 0;
}
