#include <cstdio>
#include <algorithm>
#include <deque>
#include <string>
#include <iostream>


const int MAXN = 71000;
const int SIGMA = 27;
using namespace std;


int N;
int NR;
int from[MAXN] ;
int found[SIGMA], foundchar[SIGMA];
int freq[SIGMA];
int mask[MAXN][SIGMA];
int pret[MAXN];
int req[SIGMA], len[MAXN];
string S[MAXN];
int pret2[MAXN];

void readInput() {
    cin >> N ;
    
    for( int i = 0 ; i < N; ++i) {
	cin >> S[i]; 
	len[i] = S[i].length() ;
	for( int j = 0; j < len[i] ; ++j)
	    mask[i][j] |= (1 << (S[i][j] - 'a'));
    }
}

void ASK(int ch) {   
    
    cout << "0 " << char(ch + 'a') <<"\n";
    cout.flush();

    cin >> NR;
    
    for (int i = 0 ; i < NR; ++i) {
	int pos;
	cin >> pos;
	req[i] = pos;
    }

}

void RESPOND(int pos) {
    cout << "1 "<< S[pos]<<"\n";
    cout.flush();
    int X;
    cin >> X;
}
void clear(int L) {
    for(int i = 0 ; i < L; ++i)
	found[i] = 0;
    for(int i = 0; i < SIGMA; ++i)
	foundchar[i] = 0;
}
void Solve(int L) {
    
    pret[0] = 0;
    for( int i = 0 ; i < N; ++i) {
	if( len[i] == L) {
	    ++pret[0];
	    pret[pret[0]] = i;
//	    cout << i << " " << L << "\n";
	}
    }
    clear(L);
    while(pret[0] > 1) {
	
    	for(int i = 0 ; i < SIGMA; ++i)
	    freq[i] = 0;
	
	from[0] = 0;

/*
	cout << "this is my current string list\n";

	for (int i = 1; i <= pret[0]; ++i)
	    cout << S[pret[i]] << "\n";
*/	
//	cout << "this is the end of my current list\n";
	
	for( int i = 1; i <= pret[0]; ++i) {
	    for( int pos = 0; pos < L; ++pos) {
		if (found[pos]) continue;
		
		for (int j = 0 ; j < SIGMA; ++j) {
		    if (foundchar[j]) continue;

		    if( mask[pret[i]][pos] & (1 << j) )
			++freq[j];
		}
	    }
	}
	
	int mx = -1;

	for (int i = 0 ; i < SIGMA; ++i) {
	    if (foundchar[i]) continue;
	    mx = max( mx, freq[i] );
	}
		
	for (int i = 0 ; i < SIGMA; ++i) {
	    if (foundchar[i]) continue;
	    
	    if(mx == freq[i]) { 
		from[++from[0]] = i;
	    }
	}
	
	int pchar = rand() % from[0] + 1; 
	int mychar = from[pchar];
	
//	printf("\nmychar%d\n", mychar);
	ASK(mychar); 
		
	foundchar[mychar] = 1;
	
	pret2[0] = 0;

	for (int i = 0 ; i < NR; ++i)
	    found[req[i]] = 1;
	
	if(NR != 0) {
		for (int j = 1 ; j <= pret[0] ; ++j) {
		    
		    bool ok = 1; 
		    for(int i = 0 ; i < NR; ++i) {
			if ( (mask[ pret[j] ][req[i]] & (1 << mychar)) == 0) {
			    ok = 0; 
			    break;
			}
		    }
		if(ok)
		    pret2[++pret2[0]] = pret[j];
		}
	}

	else {
	//    printf("muhahaha\n%d\n", mychar);
	    for (int i = 1; i <= pret[0]; ++i) {
		bool ok = 1;	
		
		for (int j = 0 ; j < L; ++j) {
		    if( mask[pret[i]][j] & (1 << mychar) ) {
			 ok = 0; 
			 break;
		    }
		}

	//	printf("->%d\n", ok);
	     	
		if(ok)
		    pret2[++pret2[0]] = pret[i];
	    }
	}

	for (int i = 0 ; i <= pret2[0]; ++i)
	    pret[i] = pret2[i];
	
    }

    RESPOND(pret[1]);
}
int main() {

    srand(time(NULL));
    readInput() ; 
    int T;
    cin >> T;
    
    while(T--) {
	int lungime;
	cin >> lungime;
	Solve(lungime);
    }
    return 0;
}
